"""
liest eine Textdatei ein und entfernt überflüssige Zeichen.
"""

def lesen(dateiname):
  """
  Parameter:
    str dateiname
  Rückgabe:
    str : der Text aus der Datei dateiname aus
          Zeichen, die alphanumerisch oder Satzendezeichen sind,
          und ohne Folgen von Leerzeichen
  """
  # Öffne die Datei.
  datei = open(dateiname, 'r')
  # text enthält den aus der Datei übernommenen Text.
  text = ' '
  # Alle Zeilen der Datei werden zeichenweise durchgegangen.
  # '\n' am Zeilenende werden entfernt.
  for zeile in datei:
    for c in zeile.rstrip():
      # Wenn das Zeichen alphanumerisch oder ein Satzendezeichen ist
      # oder wenn es ein Leerzeichen ist, das nicht auf ein Leerzeichen folgt,
      # dann wird es in text übernommen.
      if c.isalnum() or c in '.!?' or (c.isspace() and not text[-1].isspace()): 
          text +=  c
    # Am Zeilenende wird ein Leerzeichen eingefügt, falls nötig.
    if not text[-1].isspace(): text += ' '
  datei.close()
  return text.strip()

#---------------------------------------------------------------------------------------------------

def test():
  """
  Liest einen Dateinamen ein, wandelt die Datei mit lies() in einen String um und gibt den String aus.
  """
  import sys
  dateiname = sys.argv[1]
  
  text = lesen(dateiname)
  print(text)

#---------------------------------------------------------------------------------------------------
if __name__ == '__main__': test()
#---------------------------------------------------------------------------------------------------
# more test.txt
# Weine nicht_,  wenn  der   	 Regen fällt, dam dam, dam dam!
# Es gibt einen, der zu dir hält, dam dam, dam dam. (1234 5) 
#
# python3 einlesen.py test.txt
# Weine nicht wenn der Regen fällt dam dam dam dam! Es gibt einen der zu dir hält dam dam dam dam. 1234 5

