"""
schreibt Texte aus Ngrammen.
"""
#--------------------------------------------------------------------------------------------------
from zerlegen import nGrammAnalyse
from einlesen import lesen
import sys, random
#--------------------------------------------------------------------------------------------------

def schreibe(n, ngrammMuster):
  """
  Parameter: 
  int n 
  dict ngrammMuster: ein Dictionary mit n-Grammen (str) als Schlüsseln und einem Array 
                aus Folgebuchstaben als Wert

  Rückgabe:
  str : ein Satz aus 200 Zeichen, der mit einem zufällig gewählten n-Gramm beginnt  
        und entsprechend den in ngrammMuster enthaltenen Wahrscheinlichkeiten fortgesetzt wird.
  """
  # Wähle einen Satzanfang.
  satz = random.choice(list(ngrammMuster))
  # Setze den Satz fort, solange es geht und er noch nicht die maximale Länge erreicht hat.
  while satz[-n:] in ngrammMuster and len(satz)<200:
    # Der Satz wird fortgesetzt, 
    # indem zufällig ein Folgebuchstabe des n-Gramms am Satzende angehängt wird.
    satz += random.choice(ngrammMuster[satz[-n:]])
  return satz

#--------------------------------------------------------------------------------------------------

def test():
  """
  Liest zwei Argumente von der Kommandozeile.
  Das erste Argument ist der Name der Datei, aus der der Eingabetext gelesen wird.
  Das zweite Argument ist eine ganze Zahl n.
  Es wird ein Satz ausgegeben, der statistisch den Folgebuchstaben von n-Grammen
  des Eingabetexts entspricht.
  """
  text = lesen(sys.argv[1])
  ngrammMuster = nGrammAnalyse(text, int(sys.argv[2]))
  satz = schreibe(int(sys.argv[2]), ngrammMuster)
  print(satz)

#--------------------------------------------------------------------------------------------------
if __name__ == '__main__': test()
#--------------------------------------------------------------------------------------------------
# python3 schreiben.py Faust.txt 4
# unless to inder Menschen? Du gut gern nun about einer supporting or limited an des Maus. Der Ton 
# Zimmel und Grausend Bäumen so wärens Weinen Stocktopheles. Gar to 5000 Landersphäre Schon wird so
# feil
