"""
erzeugt aus einem Text ein Dictionary mit den n-Grammen des Textes
als Schlüssel und einem Array aller Folgebuchstaben des n-Gramms
(mit Mehrfachvorkommen) als Wert.
"""
#---------------------------------------------------------------------------------------------
import einlesen
#---------------------------------------------------------------------------------------------

def nGrammAnalyse(text, n):
  """
  Parameter:
    str text
    int n
  Rückgabewert:
    dict : Schlüssel ist ein n-Gramm von text und Wert ist
           ein Array aus allen Folgebuchstaben des n-Gramms (mit
           Mehrfachvorkommen von Buchstaben)
  """
  # ngrammMuster ist das Dictionary aus n-Grammen und Folgebuchstabenarrays
  ngrammMuster = {}
  # Gehe durch alle Stellen des Textes mit einem Folgebuchstaben.
  for i in range(0,len(text)-n):
    ngramm = text[i:i+n]
    naechstesZeichen = text[i+n]
    # Falls noch kein Einintrag für das ngramm im Dictionary ist, erzeuge ihn.
    if ngramm not in ngrammMuster: ngrammMuster[ngramm] = []
    # Trage naechstesZeichen im Dictionary als Folgzeichen von ngramm ein.
    ngrammMuster[ngramm] += [ naechstesZeichen ]

  return ngrammMuster

#---------------------------------------------------------------------------------------------

def test():
  """ 
  Lies einen Dateinamen und n von der Kommandozeile,
  erzeuge das Dictionary aus n-Grammen und Folgebuchstaben und gib es aus.
  """
  import sys
  from einlesen import lesen
  text = lesen(sys.argv[1])

  automat = nGrammAnalyse(text, int(sys.argv[2]))
  print(automat)
  for k in sorted(automat.keys()):
    print(k, automat[k])
  
#---------------------------------------------------------------------------------------------
if __name__ == '__main__': test()
#---------------------------------------------------------------------------------------------

